/*
 * Copyright (c) 1998,1999 Vassili Bourdo
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice in the documentation and/or other materials provided with 
 *    the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN 
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __PXICON_H_INCLUDED__
#define	__PXICON_H_INCLUDED__
 
inline
HICON PxLoadIcon(HINSTANCE hInstance, LPCTSTR lpczsResource)
{
	return (HICON)LoadImage(hInstance,
		lpczsResource,IMAGE_ICON,
		GetSystemMetrics(SM_CXICON),
		GetSystemMetrics(SM_CYICON),
		LR_DEFAULTSIZE);
}
inline HICON PxLoadIcon(LPCTSTR lpczsResource)
	{ return PxLoadIcon(AfxGetInstanceHandle(), lpczsResource); }
inline HICON PxLoadIcon(HINSTANCE hInstance, UINT nResource)
	{ return PxLoadIcon(hInstance, MAKEINTRESOURCE(nResource)); }
inline HICON PxLoadIcon(UINT nResource)
	{ return PxLoadIcon(AfxGetInstanceHandle(), nResource); }

inline
HICON PxLoadIconSm(HINSTANCE hInstance, LPCTSTR lpczsResource)
{
	return (HICON)LoadImage(hInstance,
		lpczsResource,IMAGE_ICON,
		GetSystemMetrics(SM_CXSMICON),
		GetSystemMetrics(SM_CYSMICON),
		LR_DEFAULTSIZE);
}
inline HICON PxLoadIconSm(LPCTSTR lpczsResource)
	{ return PxLoadIconSm(AfxGetInstanceHandle(), lpczsResource); }
inline HICON PxLoadIconSm(HINSTANCE hInstance, UINT nResource)
	{ return PxLoadIconSm(hInstance, MAKEINTRESOURCE(nResource)); }
inline HICON PxLoadIconSm(UINT nResource)
	{ return PxLoadIconSm(AfxGetInstanceHandle(), nResource); }

inline HICON PxGetWindowIcon(HWND hWnd)
{
	HICON hIcon = (HICON)::SendMessage(hWnd, WM_GETICON, ICON_BIG, 0);
	if( !hIcon ) hIcon = (HICON)::SendMessage(hWnd, WM_GETICON, ICON_SMALL, 0);
	if( !hIcon ) hIcon = (HICON)hIcon = (HICON)GetClassLong(hWnd, GCL_HICON);
	if( !hIcon ) hIcon = (HICON)GetClassLong(hWnd, GCL_HICONSM);
	return hIcon;
}

inline HICON PxGetWindowIconSm(HWND hWnd, UINT nTimeout = 100)
{
	HICON hIcon = (HICON)::SendMessage(hWnd, WM_GETICON, ICON_SMALL, 0);
	if( !hIcon ) hIcon = (HICON)::SendMessage(hWnd, WM_GETICON, ICON_BIG, 0);
	if( !hIcon ) hIcon = (HICON)GetClassLong(hWnd, GCL_HICONSM);
	if( !hIcon ) hIcon = (HICON)hIcon = (HICON)GetClassLong(hWnd, GCL_HICON);
	return hIcon;
}

#endif	//__PXICON_H_INCLUDED__
