////////////////////////////////////////////////////////////////
// 1998 Microsoft Systems Journal
//
// If this code works, it was written by Paul DiLascia.
// If not, I don't know who wrote it.
//
#ifndef __PXMODVER_H
#define __PXMODVER_H

#ifndef _INC_SHLWAPI
#include <shlwapi.h>
#endif

//////////////////
// CPxModuleVersion version info about a module.
// To use:
//
// CPxModuleVersion ver
// if (ver.GetFileVersionInfo("_T("mymodule))) {
//		// info is in ver, you can call GetValue to get variable info like
//		CString s = ver.GetValue(_T("CompanyName"));
// }
//
// You can also call the static fn DllGetVersion to get DLLVERSIONINFO.
//
class CPxModuleVersion : public VS_FIXEDFILEINFO {
protected:
	BYTE* m_pVersionInfo;	// all version info
	struct TRANSLATION {
		WORD langID;			// language ID
		WORD charset;			// character set (code page)
	};
	TRANSLATION *m_pTranslation;
	int			 m_nTranslationCount;
	static TRANSLATION m_defaultTranslation;
public:
	CPxModuleVersion(LPCTSTR modulename = NULL);
	virtual ~CPxModuleVersion();

	BOOL GetFileVersionInfo(LPCTSTR modulename);
	CString	GetValue(LPCTSTR lpKeyName);
	static BOOL DllGetVersion(LPCTSTR modulename, DLLVERSIONINFO& dvi);
	static DWORD DllGetVersion(LPCTSTR modulename);
};

#endif
