////////////////////////////////////////////////////////////////
// CPxTrayIcon Copyright 1996 Microsoft Systems Journal.
//
// If this code works, it was written by Paul DiLascia.
// If not, I don't know who wrote it.
//
// Various changes and improvements (c) Vassili Bourdo
// if curious what was actually changed, diff it with
// original version :-]

#ifndef _PXTRAYICON_H
#define _PXTRAYICON_H

////////////////
// CPxTrayIcon manages an icon in the Windows 95 system tray. 
// 
class CPxTrayIcon: public CCmdTarget {
protected:
	NOTIFYICONDATA m_nid;			// struct for Shell_NotifyIcon args
	BOOL m_bFromFile;				// the icon was set from file - we need to destroy it
public:
	CPxTrayIcon(UINT uID);
	~CPxTrayIcon();

//
	UINT GetID() 
		{ return m_nid.uID; }
	LPCTSTR GetTip()
		{ return m_nid.szTip; }
	HICON GetIcon()
		{ return m_nid.hIcon; }
//	Call this to receive tray notifications
	void SetNotificationWnd(CWnd* pNotifyWnd, UINT uCbMsg);

//	SetIcon functions. To remove icon, call SetIcon(0)
	BOOL SetIcon(); // set icon and tooltip from application main window
	BOOL SetIcon(UINT uID); // main variant you want to use
	BOOL SetIcon(HICON hicon, LPCTSTR lpTip);
	BOOL SetIcon(LPCTSTR lpResName, LPCTSTR lpTip)
		{ return SetIcon(lpResName ? 
			AfxGetApp()->LoadIcon(lpResName) : NULL, lpTip); }
	BOOL SetStandardIcon(LPCTSTR lpszIconName, LPCTSTR lpTip)
		{ return SetIcon(::LoadIcon(NULL, lpszIconName), lpTip); }
	BOOL SetIconFromFile(LPCTSTR pszFileName, UINT nIconIndex, LPCTSTR lpTip);

	void Refresh()
		{
			HICON hSaveIcon;
			if( hSaveIcon =  m_nid.hIcon ) {
				BOOL bFromFile = m_bFromFile;
				m_bFromFile = FALSE;
				SetIcon(NULL);
				SetIcon(hSaveIcon, NULL);
				m_bFromFile = bFromFile;
			}
		}
	virtual LRESULT OnTrayNotification(WPARAM uID, LPARAM lEvent);
};

#endif
