/*
 * Copyright (c) 1998,1999 Vassili Bourdo
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice in the documentation and/or other materials provided with 
 *    the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN 
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef __PPMISC_H_INCLUDED__
#define __PPMISC_H_INCLUDED__
#pragma once
/////////////////////////////////////////////////////////////////////////////
// CPPMisc dialog

class CPPMisc : public CPropertyPage
{
	friend class COptionsSheet;
public:
	class CDesktopColor:
		public CPxColorPicker
	{
	public:
		CDesktopColor() {}
	protected:
		virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	};
	friend class CPPMisc::CDesktopColor;
private:
	//{{AFX_DATA(CPPMisc)
	enum { IDD = IDD_PPMISC };
	CCheckListBox	m_lbMenuList;
	CString	m_strPassword;
	CString	m_strPassword2;
	BOOL	m_bFixDskText;
	BOOL	m_bRegisterService;
	BOOL	m_bPasswordMenu;
	int		m_nPasswordTimeout;
	BOOL	m_bEjectCDAtExit;
	//}}AFX_DATA
	COLORREF m_crDskText;
	BOOL m_bPasswordChanged;
	CMenuIDList m_lsDisabledMenus;
	CPxTooltipManager	ttm;
public:
	CPPMisc();
	void SetData(CMainWnd* pWnd);
	void GetData(CMainWnd* pWnd);

	//{{AFX_VIRTUAL(CPPMisc)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
protected:
	CDesktopColor m_txtColor;
	// Generated message map functions
	//{{AFX_MSG(CPPMisc)
	virtual BOOL OnInitDialog();
	afx_msg void OnDesktopChange();
	afx_msg void OnPasswordChange();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif //__PPMISC_H_INCLUDED__
