/*
 * Copyright (c) 1998,1999 Vassili Bourdo
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice in the documentation and/or other materials provided with 
 *    the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN 
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef __GLOBALS_H_INCLUDED__
#define __GLOBALS_H_INCLUDED__ 

#define TIMESLICE			100
#define TIMESLICE2SEC(ts)	(TIMESLICE*(ts))/1000
#define SEC2TIMESLICE(ts)	(1000*(ts))/TIMESLICE

#define MenuFlags			(TPM_LEFTBUTTON/*|TPM_RIGHTBUTTON*/|TPM_LEFTALIGN|TPM_TOPALIGN|TPM_RETURNCMD)
#define WM_TRAYICON			(WM_USER+1)
#define WM_RESTOREICON		(WM_USER+2)
#define WM_WNDTRAYICON		(WM_USER+3)
#define WM_SHOWPROPERTIES	(WM_USER+4)
#define WM_SHELLMENU		(WM_USER+5) //wParam: flags (see enum ShellMenuFlags); lParam: index in menu array
#define WM_FIXDSKTEXT		(WM_USER+6)
#define WM_WNDMINIMIZE		(WM_USER+7) //defined in wcathk.h
#define WM_WNDACTIVATE		(WM_USER+8) //defined in wcathk.h
#define WM_SHELLRUN			(WM_USER+9)
#define WM_SHELLTRAYICON	(WM_USER+10)

#define WM_VERIFYPASSWORD	(WM_USER+11)
#define WM_CREATETRAYICON	(WM_USER+12)
#define WM_SETJUSTHIDDEN	(WM_USER+13)
#define WM_GETCONFIG		(WM_USER+14)

enum ShellMenuFlags {
	smfMenuAtMousePos = 1,
	smfTempMenu		  = 2	//use menus from temporary array
};

// platform functions
DWORD GetPlatform(); //defined in WCAT.CPP
inline BOOL IsWinNT() { return GetPlatform() == VER_PLATFORM_WIN32_NT; }
inline BOOL IsWin95() {	return GetPlatform() == VER_PLATFORM_WIN32_WINDOWS; }
BOOL IsNewWin();	 //returns TRUE if OS is Win98 or Win2K (defined in WCAT.CPP)

#define TPM_RECURSE			0x0001L
#define WM_MENURBUTTONUP    0x0122

#endif //__GLOBALS_H_INCLUDED__
