/*
 * Copyright (c) 1998,1999 Vassili Bourdo
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice in the documentation and/or other materials provided with 
 *    the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN 
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef __PPRULESET_H_INCLUDED__
#define __PPRULESET_H_INCLUDED__
#pragma once
#include "wcatres.h"
#include "wcat.h"
#include "rule.h"

/////////////////////////////////////////////////////////////////////////////
// CppRuleSet dialog

class CppRuleSet : public CPropertyPage
{
	friend class COptionsSheet;
	CPxTooltipManager	ttm;
public:
	CppRuleSet(CWnd* pParent = NULL);   // standard constructor
	void SetData(CMainWnd* pWnd);
	void GetData(CMainWnd* pWnd);

// Dialog Data
	//{{AFX_DATA(CppRuleSet)
	enum { IDD = IDD_PPRULESET };
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CppRuleSet)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CImageList  m_ilRuleState;
	CRuleSet	m_aRuleSet;
	CListCtrl	m_lvList;
	CWnd* operator[](int nCtrlID)
		{
			CWnd* pWnd = GetDlgItem(nCtrlID);
			if( !pWnd ) AfxThrowResourceException();
			return pWnd;
		}
	void UpdateItem(UINT nItem);


	// Generated message map functions
	//{{AFX_MSG(CppRuleSet)
	virtual BOOL OnInitDialog();
	afx_msg void OnListGetdispInfo(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnListItemChanged(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnListKeyDown(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnAdd();
	afx_msg void OnEdit();
	afx_msg void OnDelete();
	afx_msg void OnMoveDn();
	afx_msg void OnMoveUp();
	afx_msg void OnDestroy();
	afx_msg void OnTest();
	afx_msg void OnListDblClick(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
#endif //__PPRULESET_H_INCLUDED__
