/*
 * Copyright (c) 1998,1999 Vassili Bourdo
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice in the documentation and/or other materials provided with 
 *    the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN 
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef __PPFOLDERS_H_INCLUDED__
#define __PPFOLDERS_H_INCLUDED__
#pragma once

#include "wcat.h"
#include "shlcache.h"

/////////////////////////////////////////////////////////////////////////////
// CPPFolders dialog
class CPPFolders : public CPropertyPage
{
	friend class COptionsSheet;
	CShlRootArray m_aItemData;
	CPxTooltipManager	ttm;
public:
	CPPFolders();
	void SetData(CMainWnd* pWnd);
	void GetData(CMainWnd* pWnd);
protected:
	//{{AFX_DATA(CPPFolders)
	enum { IDD = IDD_PPFOLDERS };
	CButton	m_cbTrayIcon;
	CButton	m_cbSortByType;
	CEdit	m_edNestLevel;
	CEdit	m_edFileMask;
	CButton	m_cbFoldersOnTop;
	CButton	m_cbShowHidden;
	CButton	m_cbExpandRemovable;
	CButton	m_cbExpandLinks;
	CListCtrl	m_lvList;
	CHotKeyCtrl	m_hkMenuKey;
	CEdit	m_edMenuName;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPPFolders)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CWnd* operator[](int nCtrlID)
		{
			CWnd* pWnd = GetDlgItem(nCtrlID);
			if( !pWnd ) AfxThrowResourceException();
			return pWnd;
		}
	void UpdateItem(UINT nItem);
	void SetOption(CButton* btn, int nOpt);
	LPITEMIDLIST BrowseForFolder(LPITEMIDLIST pidlStart=NULL);
	// Generated message map functions
	//{{AFX_MSG(CPPFolders)
	virtual BOOL OnInitDialog();
	afx_msg void OnBrowseClick();
	afx_msg void OnListGetdispinfo(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnListItemChanged(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnHkSaveClick();
	afx_msg void OnMenunameChange();
	afx_msg void OnAddClick();
	afx_msg void OnDelClick();
	afx_msg void OnMovednClick();
	afx_msg void OnMoveupClick();
	afx_msg void OnTestMenu();
	afx_msg void OnNestLevelChange();
	afx_msg void OnFilemaskChange();
	afx_msg void OnExpandLinksChange();
	afx_msg void OnExpandRemovableChange();
	afx_msg void OnFoldersOnTopChange();
	afx_msg void OnrShowHiddenChange();
	afx_msg void OnDestroy();
	afx_msg void OnSortByTypeChange();
	afx_msg void OnTrayIconChange();
	afx_msg void OnListKeyDown(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnListDblClick(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif //__PPFOLDERS_H_INCLUDED__
