/*
 * Copyright (c) 1998,1999 Vassili Bourdo
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice in the documentation and/or other materials provided with 
 *    the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN 
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef __WCATHK_H_INCLUDED__
#define __WCATHK_H_INCLUDED__

extern "C" {
	BOOL	FAR WINAPI SetHook(HMODULE hThisDll, HWND hWnd);
	typedef BOOL (FAR WINAPI *lpfnSetHook)(HMODULE hThisDll, HWND hWnd);

	VOID	FAR WINAPI RemoveHook(void);
	typedef VOID (FAR WINAPI *lpfnRemoveHook)(void);

	HWND	FAR WINAPI IsHookSet(void);
	typedef HWND (FAR WINAPI *lpfnIsHookSet)(void);

	BOOL	FAR WINAPI GetWndCWD(HWND hWnd, LPTSTR pszCwd, DWORD cbCwdMaxLen);
	typedef BOOL (FAR WINAPI *lpfnGetWndCWD)(HWND hWnd, LPTSTR pszCwd, DWORD cbCwdMaxLen);

	BOOL FAR WINAPI SetWndCWD(HWND hWnd, LPTSTR pszCwd);
	typedef BOOL (FAR WINAPI *lpfnSetWndCWD)(HWND hWnd, LPTSTR pszCwd);
}

typedef union tagClickData {
	struct {
		BYTE	bLongClick:1;
		BYTE	nMouseButton:2;
		WORD	nHitTestCode:16;
	};
	DWORD dwData;
} CLICKDATA;

#endif //__WCATHK_H_INCLUDED__
